/*******************************************************************************
  *
  *  program     : MainFrame.java
  *  author      : Helge Janicke
  *  version     : 2000-10-19(001)
  *  (c)         : Helge Janicke, Karsten Wolke, Niels-Peter de Witt
  *  email       : heljanic@agent.fho-emden.de
  *  description : Ein einfaches Zeichen-Programm in Java, da mit mehreren
  *                Ebenen arbeitet. Die einzelnen Ebenen knnen mit alpha-
  *                blending kombiniert werden.<p>
  *
  ******************************************************************************
  * modifications:
  * date: ******* who: ****** description: *************************************
  * ----------------------------------------------------------------------------
  * 2000-10-19    heljanic    your description here
  * ----------------------------------------------------------------------------
  ******************************************************************************
  * comments:
  *
  ******************************************************************************
  * license:
  *
*******************************************************************************/

package jdraw;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;

import javax.swing.event.MouseInputAdapter;
import javax.swing.tree.*;
import javax.swing.JTree;
import javax.swing.JLabel;
import java.awt.*;
import java.awt.geom.*;
import java.awt.event.MouseEvent;
import java.util.Enumeration;
import java.net.URL;

/** This is the GUI.
  * Diese Klasse ist weitestgehend undokumentiert, da sie in nchster Zeit
  * grndlich berarbeitet werden wird.
  */
public class MainFrame extends JFrame {

  final static jdLineGenerator lineGenerator = new jdLineGenerator();
  final static jdRectangleGenerator rectGenerator = new jdRectangleGenerator();
  final static URL noHelp = MainFrame.class.getResource("noHelp.html");

  private HyperlinkListener helpHyperlinkListener = new HyperlinkListener() {
    public void hyperlinkUpdate( HyperlinkEvent e ) {
      if ( e.getEventType() == HyperlinkEvent.EventType.ACTIVATED ) {
        try {
          // .setEditable(false);
          textpaneHelp.setPage(e.getURL());
        } catch (Exception exc ) {
          JOptionPane.showMessageDialog(textpaneHelp, "unable to Open the following URL: " + e.getURL());
        }
      }
    }
  };


  TreeSelectionListener treeListener = new TreeSelectionListener() {
    public void valueChanged(TreeSelectionEvent e) {
      TreePath selPath = e.getPath();
      TreePath[] selPaths = treeShapes.getSelectionPaths();
      DefaultMutableTreeNode selNode = (DefaultMutableTreeNode) selPath.getLastPathComponent();
      DefaultMutableTreeNode groupNode = null;

      if (!selNode.getAllowsChildren()) {
        groupNode = (DefaultMutableTreeNode) selNode.getParent();
        selPath = selPath.getParentPath();
      } else groupNode = selNode;

      if (groupNode == null) return;

      if (groupNode.equals(rootNode)) {
        try {
          groupNode = (DefaultMutableTreeNode) rootNode.getFirstChild();
        } catch (java.util.NoSuchElementException exc) {
          butNewLayer_actionPerformed(null);
        }

        Object[] obj = new Object[] { rootNode, groupNode };
        TreePath t = new TreePath(obj);
        treeShapes.setSelectionPath(t);

      }

      if (!uda.getNode().equals(groupNode)) {
        // glassPane.clearSelection();
        uda.setNode(groupNode);
      }

      if (selPaths != null) {
        glassPane.clearSelection();
        glassPane.addSelection(Color.blue);

        for (int i=0; i<selPaths.length; i++) {
          DefaultMutableTreeNode selectNode = (DefaultMutableTreeNode) selPaths[i].getLastPathComponent();
          if (selectNode.getUserObject() instanceof Selectable) {
            glassPane.addSelection(Color.red);
            glassPane.addSelection((Selectable) selectNode.getUserObject());
            // System.err.println("no = " + i + "path = " + selPaths[i] );
            // System.err.println("\tselectable = " + (Selectable) selectNode.getUserObject());
          }
        }
      }

      glassPane.refresh();
    }
  };

  class UnitsListener implements ItemListener {

    public void itemStateChanged(ItemEvent e) {
        if (e.getSource() instanceof JToggleButton) {
          if (grid.getUnit().equals(Unit.INCH_UNIT) ) {
            grid.setUnit(Unit.CM_UNIT);
          } else {
            grid.setUnit(Unit.INCH_UNIT);
          }
          ((JToggleButton) e.getSource()).setText(grid.getUnit().getName());
          columnView.setIncrementAndUnits();
          rowView.setIncrementAndUnits();
          columnView.repaint();
          rowView.repaint();
        }

    }
  }

  SimpleGrid grid = new SimpleGrid();
  JPanel contentPane;
  JMenuBar menuBar1 = new JMenuBar();
  JMenu menuFile = new JMenu();
  JMenuItem menuFileExit = new JMenuItem();
  JMenu menuHelp = new JMenu();
  JMenuItem menuHelpAbout = new JMenuItem();
  JToolBar toolBar = new JToolBar();
  JButton butOpen = new JButton();
  JButton butSave = new JButton();
  JButton butHelp = new JButton();
  ImageIcon image1;
  ImageIcon image2;
  ImageIcon image3;
  BorderLayout borderLayout1 = new BorderLayout();
  JToolBar toolbarShapes = new JToolBar();
  JToggleButton butSelect = new JToggleButton();
  JToggleButton butLine = new JToggleButton();
  JToggleButton butRectangle = new JToggleButton();
  JToggleButton butEllipse = new JToggleButton();
  JSplitPane splitGUI = new JSplitPane();
  JPanel jPanel2 = new JPanel();
  JTabbedPane jTabbedPane1 = new JTabbedPane();
  BorderLayout borderLayout3 = new BorderLayout();
  JPanel panHelp = new JPanel();
  JPanel panTree = new JPanel();
  JScrollPane scrHelp = new JScrollPane();
  BorderLayout borderLayout4 = new BorderLayout();
  JTextPane textpaneHelp = new JTextPane();
  JScrollPane scrTree = new JScrollPane();
  BorderLayout borderLayout5 = new BorderLayout();
  DefaultMutableTreeNode rootNode = new DefaultMutableTreeNode("gesamte Zeichnung");
  DefaultTreeModel treeModel = new DefaultTreeModel(rootNode);
  JTree treeShapes = new JTree(treeModel);
  UserDrawAction uda = new UserDrawAction(rootNode, treeShapes);
  DefaultGlassPane glassPane = null;
  JPanel jPanel1 = new JPanel();
  JButton butNewLayer = new JButton();
  JPanel panStatus = new JPanel();
  JPanel panScrollDrawArea = new JPanel();
  BorderLayout borderLayout7 = new BorderLayout();
  BorderLayout borderLayout6 = new BorderLayout();
  BorderLayout borderLayout2 = new BorderLayout();
  JScrollPane scrBoard = new JScrollPane();
  JPanel panDrawArea = new JPanel();
  JLabel panBoard = getBoard(rootNode);
  JButton butLayerVisible = new JButton();
  JLabel lblPosition = new JLabel();
  JPanel panInfo = new JPanel();
  Rule columnView;
  Rule rowView;
  JToggleButton isMetric;
  BorderLayout borderLayout8 = new BorderLayout();

  //Construct the frame
  public MainFrame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception  {
    image1 = new ImageIcon(MainFrame.class.getResource("openFile.gif"));
    image2 = new ImageIcon(MainFrame.class.getResource("closeFile.gif"));
    image3 = new ImageIcon(MainFrame.class.getResource("closeFile.gif"));
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(borderLayout1);
    this.setSize(new Dimension(657, 659));
    this.setTitle("JDraw testphase");
    menuFile.setText("File");
    menuFileExit.setText("Exit");
    menuFileExit.addActionListener(new MainFrame_menuFileExit_ActionAdapter(this));
    menuHelp.setText("Help");
    menuHelpAbout.setText("About");
    menuHelpAbout.addActionListener(new MainFrame_menuHelpAbout_ActionAdapter(this));
    butOpen.setIcon(image1);
    butOpen.setToolTipText("Open File");
    butSave.setIcon(image2);
    butSave.setToolTipText("Save File");
    butHelp.setIcon(image3);
    butHelp.setToolTipText("Help");
    toolbarShapes.setOrientation(JToolBar.VERTICAL);
    toolbarShapes.setFloatable(false);
    butSelect.setText("S");
    butSelect.addActionListener(new MainFrame_butSelect_actionAdapter(this));
    butLine.setText("L");
    butLine.addActionListener(new MainFrame_butLine_actionAdapter(this));
    butRectangle.setText("R");
    butRectangle.addActionListener(new MainFrame_butRectangle_actionAdapter(this));
    butEllipse.setText("E");
    butEllipse.addActionListener(new MainFrame_butEllipse_actionAdapter(this));
    splitGUI.setOrientation(JSplitPane.VERTICAL_SPLIT);
    splitGUI.setDividerSize(4);
    splitGUI.setLastDividerLocation(400);
    jPanel2.setLayout(borderLayout3);
    jTabbedPane1.setTabPlacement(JTabbedPane.LEFT);
    jTabbedPane1.setMinimumSize(new Dimension(0, 0));
    panHelp.setLayout(borderLayout4);
    panTree.setLayout(borderLayout5);
    textpaneHelp.setMinimumSize(new Dimension(0, 0));
    textpaneHelp.setEditable(false);
    panHelp.setMinimumSize(new Dimension(0, 0));
    scrHelp.setMinimumSize(new Dimension(0, 0));
    panTree.setMinimumSize(new Dimension(0, 0));
    scrTree.setMinimumSize(new Dimension(0, 0));
    jPanel1.setBorder(BorderFactory.createEtchedBorder());
    jPanel1.setPreferredSize(new Dimension(10, 40));
    butNewLayer.setToolTipText("Erzeugt eine neue Ebene");
    butNewLayer.setActionCommand("Gruppe einfgen");
    butNewLayer.setText("neue Ebene");
    butNewLayer.addActionListener(new MainFrame_butNewLayer_actionAdapter(this));
    panStatus.setLayout(borderLayout2);
    panStatus.setBorder(BorderFactory.createEtchedBorder());
    panStatus.setPreferredSize(new Dimension(1, 35));
    panScrollDrawArea.setLayout(borderLayout7);
    panDrawArea.setLayout(borderLayout6);
    panDrawArea.setPreferredSize(new Dimension(10, 300));
    scrBoard.setAutoscrolls(true);
    treeShapes.setEditable(false);
    treeShapes.setModel(treeModel);
    treeShapes.setShowsRootHandles(true);
    treeShapes.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyPressed(KeyEvent e) {
        treeShapes_keyPressed(e);
      }
    });
    toolBar.setFloatable(false);
    butLayerVisible.setText("(un)sichtbar");
    butLayerVisible.addActionListener(new MainFrame_butLayerVisible_actionAdapter(this));
    lblPosition.setText("jLabel1");
    toolBar.add(butOpen);
    toolBar.add(butSave);
    toolBar.add(butHelp);
    contentPane.add(splitGUI, BorderLayout.CENTER);
    splitGUI.add(jPanel2, JSplitPane.RIGHT);
    jPanel2.add(jTabbedPane1, BorderLayout.CENTER);
    jTabbedPane1.add(panHelp, "H");
    panHelp.add(scrHelp, BorderLayout.CENTER);
    scrHelp.getViewport().add(textpaneHelp, null);
    jTabbedPane1.add(panTree, "T");
    panTree.add(scrTree, BorderLayout.CENTER);
    panTree.add(jPanel1, BorderLayout.NORTH);
    jPanel1.add(butNewLayer, null);
    jPanel1.add(butLayerVisible, null);
    splitGUI.add(panDrawArea, JSplitPane.LEFT);
    panDrawArea.add(panStatus, BorderLayout.SOUTH);
    panStatus.add(lblPosition, BorderLayout.EAST);
    panStatus.add(panInfo, BorderLayout.CENTER);
    panDrawArea.add(panScrollDrawArea, BorderLayout.CENTER);
    panScrollDrawArea.add(scrBoard, BorderLayout.CENTER);

    scrBoard.getViewport().add(panBoard, null);
    scrBoard.getViewport().setAutoscrolls(true);

    columnView = new Rule(Rule.HORIZONTAL, grid);
    columnView.setPreferredWidth(scrBoard.getViewport().getViewSize().width);
    rowView = new Rule(Rule.VERTICAL, grid);
    rowView.setPreferredHeight(scrBoard.getViewport().getViewSize().height);
    scrBoard.setColumnHeaderView(columnView);
    scrBoard.setRowHeaderView(rowView);

    // Create the corners.
    JPanel buttonCorner = new JPanel();
    isMetric = new JToggleButton("cm", true);
    isMetric.setFont(new Font("SansSerif", Font.PLAIN, 11));
    isMetric.setMargin(new Insets(2,2,2,2));
    isMetric.addItemListener(new UnitsListener());
    isMetric.setBorder(null);

    buttonCorner.setLayout(borderLayout8);
    buttonCorner.add(isMetric, BorderLayout.CENTER); //Use the default FlowLayout
    // Set the corners.
    scrBoard.setCorner(JScrollPane.UPPER_LEFT_CORNER, buttonCorner);
    // scrBoard.setCorner(JScrollPane.LOWER_LEFT_CORNER, new Corner());
    // scrBoard.setCorner(JScrollPane.UPPER_RIGHT_CORNER, new Corner());

    scrTree.getViewport().add(treeShapes, null);
    contentPane.add(toolbarShapes, BorderLayout.WEST);
    toolbarShapes.add(butSelect, null);
    toolbarShapes.add(butLine, null);
    toolbarShapes.add(butRectangle, null);
    toolbarShapes.add(butEllipse, null);
    menuFile.add(menuFileExit);
    menuHelp.add(menuHelpAbout);
    menuBar1.add(menuFile);
    menuBar1.add(menuHelp);
    this.setJMenuBar(menuBar1);
    contentPane.add(toolBar, BorderLayout.NORTH);
    splitGUI.setDividerLocation(300);
    jTabbedPane1.setSelectedIndex(1);
    treeShapes.addTreeSelectionListener(treeListener);
    // uda.setNode(addObject("Ebene 0"));
    butNewLayer_actionPerformed(null);
    uda.setPositionLabel(lblPosition);
    glassPane.setInfoPanel(panInfo);

    textpaneHelp.addHyperlinkListener(helpHyperlinkListener);

    grid.setEnabled(true);
  }

  //File | Exit action performed
  public void fileExit_actionPerformed(ActionEvent e) {
    System.exit(0);
  }

  //Help | About action performed
  public void helpAbout_actionPerformed(ActionEvent e) {
    MainFrame_AboutBox dlg = new MainFrame_AboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.show();
  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      fileExit_actionPerformed(null);
    }
  }

  /** Erzeugt ein JPanel, da ein Scrollpane mit dem LayerPainter, sowie einer
   * darberliegenden GlassPane, enthlt.
   */
  private JLabel getBoard(DefaultMutableTreeNode rootNode) {
    JPanel layerPanel = new JPanel();

    LayerPainter layerPainter = new LayerPainter(rootNode);
    OverlayLayout overlayLayout = new OverlayLayout(layerPainter);
    glassPane = new DefaultGlassPane();

    layerPainter.setPreferredSize(new Dimension(1000,800));
    glassPane.setPreferredSize(layerPainter.getPreferredSize());
    glassPane.setOpaque(false);

    layerPainter.setLayout(overlayLayout);
    layerPainter.add(glassPane, null);

//    layerPainter.setAutoscrolls(true);
//    JScrollPane layerScrollPane = new JScrollPane(layerPainter);

    layerPanel.setLayout(new BorderLayout());
    // layerPanel.add(layerPainter);
//    layerPanel.add(layerScrollPane);
    glassPane.setRefreshComponent(scrBoard);

    glassPane.addMouseListener(uda);
    glassPane.addMouseMotionListener(uda);

    layerPainter.setAutoscrolls(true);
    glassPane.setAutoscrolls(true);

    return layerPainter;
  }

  void butSelect_actionPerformed(ActionEvent e) {
    resetShapeButtons();
    butSelect.setSelected(true);
    uda.setMode(UserDrawAction.SELECTMODE);
    try {
      textpaneHelp.setPage(noHelp);
    }
    catch (Exception ex) {
      // textpaneHelp.setText("no Helpfile available for this mode!");
    }
  }

  void butLine_actionPerformed(ActionEvent e) {
    resetShapeButtons();
    butLine.setSelected(true);
    // uda.setStatus(UserDrawAction.LINEMODE);
    lineGenerator.setGlassPane(glassPane);
    uda.setDrawMode(lineGenerator);
    lineGenerator.setHTMLHelpPane(textpaneHelp);
    try {
      if (lineGenerator.getHTMLHelp() != null) {
        textpaneHelp.setPage(lineGenerator.getHTMLHelp());
      } else {
        textpaneHelp.setPage(noHelp);
      }
    }
    catch (Exception ex) {
      //textpaneHelp.setText("no Helpfile available for this mode!");
      ex.printStackTrace();
    }
  }

  void butRectangle_actionPerformed(ActionEvent e) {
    resetShapeButtons();
    butRectangle.setSelected(true);
    // uda.setStatus(UserDrawAction.RECTANGLEMODE);
    rectGenerator.setGlassPane(glassPane);
    uda.setDrawMode(rectGenerator);
    try {
      textpaneHelp.setPage(rectGenerator.getHTMLHelp());
    }
    catch (Exception ex) {
      //textpaneHelp.setText("no Helpfile available for this mode!");
    }
  }

  void butEllipse_actionPerformed(ActionEvent e) {
    resetShapeButtons();
    butEllipse.setSelected(true);
    // uda.setStatus(UserDrawAction.CIRCLEMODE);
  }

  private void resetShapeButtons() {
    Component[] buts = toolbarShapes.getComponents();
    for( int i=0; i<buts.length; i++) {
      if (buts[i] instanceof JToggleButton) {
        ((JToggleButton) buts[i]).setSelected(false);
      }
    }
  }

  /** Setzt einen neuen Knoten an den parentNode und bergibt diesen an die
   * GlassPane.
   */
  private void newNode(DefaultMutableTreeNode parentNode) {
    DefaultMutableTreeNode node = new DefaultMutableTreeNode();
    parentNode.add(node);
    uda.setNode(node);
  }

  void butNewLayer_actionPerformed(ActionEvent e) {
    Layer layer = new Layer("Ebene " + (rootNode.getChildCount()));
    DefaultMutableTreeNode newNode = addObject(rootNode, layer);
    layer.setAlpha(AlphaComposite.SRC_OVER, (float) (1.0f / (rootNode.getChildCount())));
    if ((rootNode.getChildCount()) == 2) layer.setVisible(false);
    uda.setNode(newNode);
    Object[] obj = new Object[] {rootNode, newNode};
    treeShapes.setSelectionPath(new TreePath(obj));
  }

  public DefaultMutableTreeNode addObject(Object child) {
    DefaultMutableTreeNode parentNode =  null;
    TreePath parentPath = treeShapes.getSelectionPath();

    if (parentPath == null) {
      //There's no selection. Default to the root node.
      parentNode = rootNode;
    } else {
      parentNode = (DefaultMutableTreeNode) (parentPath.getLastPathComponent());
    }

    if (!parentNode.getAllowsChildren()) parentNode = (DefaultMutableTreeNode) parentNode.getParent();

    return addObject(parentNode, child);
  }

  public DefaultMutableTreeNode  addObject(DefaultMutableTreeNode parentNode, Object child) {
    DefaultMutableTreeNode childNode = new DefaultMutableTreeNode(child);
    childNode.setAllowsChildren(true);
    treeModel.insertNodeInto(childNode, parentNode, parentNode.getChildCount());
    // Make sure the user can see the lovely new node.
    treeShapes.scrollPathToVisible(new TreePath(childNode.getPath()));
    return childNode;
  }

  void butLayerVisible_actionPerformed(ActionEvent e) {
    TreePath[] selection = treeShapes.getSelectionPaths();
    if (selection == null) return;
    for (int i=0; i<selection.length;i++) {
      DefaultMutableTreeNode node = (DefaultMutableTreeNode) selection[i].getLastPathComponent();
      Object obj = node.getUserObject();
      if (obj instanceof Layer) {
        Layer l = (Layer) obj;
        l.setVisible(!l.isVisible());
      }
    }
    treeShapes.updateUI();
    glassPane.refresh();
  }



  class UserDrawAction extends MouseInputAdapter {

    public final static int SELECTMODE = 0;
    public final static int ROTATEMODE = 1;
    public final static int SHEARMODE  = 2;
    public final static int DRAWMODE   = 3;

    private Rectangle2D mouseRectangle = new Rectangle2D.Double(0,0,8,8);

    private int mode = SELECTMODE;
    private Drawable drawable = null;
    private DefaultMutableTreeNode node = null;
    private AbstractAccessPoint currentAccessPoint = null;
    private Cursor currentCursor = Cursor.getDefaultCursor();
    private boolean canDrag = false;
    private boolean dragged = false;
    private Point2D startPoint = new Point2D.Double();
    private Selectable remOnRelease = null;
    private Selectable clearAndAddOnRelease = null;
    private DefaultTreeModel treeModel = null;
    private JTree tree;
    private JLabel lblPosition;

    public UserDrawAction() {
    }

    public UserDrawAction(DefaultMutableTreeNode node, JTree tree) {
      this();
      this.tree = tree;
      this.treeModel = (DefaultTreeModel) tree.getModel();
      setNode(node);
    }

    public void mousePressed(MouseEvent e) {
      GlassPane glasspane = null;
      if (e.getSource() instanceof GlassPane) glasspane = (GlassPane) e.getSource();
      // wenn nicht klar ist wohin gezeichnet werden kann, bzw worauf brechen wir ab.
      if (getNode() == null || glasspane == null) return;

      // Solange nichts angeklickt wurde, kann man auch nichts ziehen.
      // canDrag = false;
      startPoint.setLocation(e.getPoint());
      switch (getMode()) {
        case SELECTMODE:
          AbstractAccessPoint ap;
          Selectable selectable;
          ap = hitsAccessPoint(e);
          if (ap != null) {
            // Benutzer hat die mouse auf einem AbstractAccessPoint gedrckt.
            setCurrentAccessPoint(ap);
            Selectable sel = glasspane.getSelectable();
            if (sel instanceof Transformable) {
              // Eine Sicherheitsberprfung, da es eigentlich ein Transformable sein mu
              ((Transformable) sel).handleAccessPointPressed(e, ap);
            } else {
              System.err.println("UserDrawAction: \n\tEs waren AccessPoints vorhanden, obwohl die Auswahl nicht Transformable war!");
            }
          } else if ((selectable = hitsSelectable(e)) != null) {
            // Benutzer hat ein Selectable angeklickt.
            // und kann die Auswahl also auch bewegen.
            // canDrag = true;
            if (e.isShiftDown() || e.isControlDown() ) {
              // mehrfache Auswahl erlauben.
              if (glasspane.isSelected(selectable)) {
                // ist bereits ausgewhlt -> Aus Auswahl entfernen.
                remOnRelease = selectable;
  //              glasspane.remSelection(selectable);
  //              if (glasspane.getSelection() == null) {
                  // wir haben die letzte Auswahl aufgehoben...
  //                canDrag = false;

  //              }
              } else {
                // ist noch nicht ausgewhlt -> auswhlen.
                glasspane.addSelection(Color.blue);
  //              System.err.println("adding to selection: "+ selectable);
                glasspane.addSelection(selectable);
              }
            } else {
              if (glasspane.isSelected(selectable)) {
                // nur einfache Auswahl.
                // und schon ausgewhlt.
                clearAndAddOnRelease = selectable;
              } else {
                // nur einfache Auswahl.
                // noch nicht ausgewhlt.
                glasspane.clearSelection();
                glasspane.addSelection(Color.blue);
    //            System.err.println("adding to selection: "+ selectable);
                glasspane.addSelection(selectable);
              }
            }
          } else {
            // Benutzer hat nichts angeklickt -> Auswahl aufheben wenn nicht Shift || Ctrl
            if (!e.isShiftDown() && !e.isControlDown()) {
              // Auswahl aufheben.
              glasspane.clearSelection();
            }
          }

          break;
        case ROTATEMODE:
          System.err.println("ROTATEMODE NI!");
          break;
        case SHEARMODE:
          System.err.println("SHEARMODE NI!");
          break;
        case DRAWMODE:
          if (getDrawable() != null) {
            if (getDrawable().handleMousePressed(grid.getClosestEvent(e))) {
              // Es sind gengend Informationen um das Objekt zu erzeugen.
              add(glasspane);
            }
          } else {
            System.err.println("UserDrawAction:\n\tgetMode() == DRAWMODE && getDrawable() == null");
          }
          break;
        default:
          System.err.println("UserDrawAction: \n\tNOT A DEFINED DRAWING MODE!!!");
      }
      glasspane.refresh();
    }

    public void mouseDragged(MouseEvent e) {
      GlassPane glasspane = null;
      if (e.getSource() instanceof GlassPane) glasspane = (GlassPane) e.getSource();
      // wenn nicht klar ist wohin gezeichnet werden kann, bzw worauf brechen wir ab.
      if (getNode() == null || glasspane == null) return;

      switch (getMode()) {
        case SELECTMODE:
          AbstractAccessPoint ap;
          Selectable selectable;
          ap = getCurrentAccessPoint();
          remOnRelease = null;
          clearAndAddOnRelease = null;
          if (ap != null) {
            // Benutzer hat einen AccessPoint gedragged.

            Selectable sel = glasspane.getSelectable();
            if (sel instanceof Transformable) {
              // Eine Sicherheitsberprfung, da es eigentlich ein Transformable sein mu
              ((Transformable) sel).handleAccessPointDragged(e, ap);
            } else {
              System.err.println("UserDrawAction: \n\tEs waren AccessPoints vorhanden, obwohl die Auswahl nicht Transformable war!");
            }
          } else if ((selectable = glasspane.getSelectable()) != null) {
            // Benutzer hat ein Selectable gedragged.

            if (selectable instanceof Transformable) {
              // Eine Sicherheitsberprfung, da es eigentlich ein Transformable sein mu
              dragged = true;
              ((Transformable) selectable).handleDrag(e, startPoint);
            } else {
              System.err.println("UserDrawAction: \n\tEs wurde versucht ein Selectable zu draggen, obwohl es nicht Transformable war!");
            }
          }
          break;
        case ROTATEMODE:
          System.err.println("ROTATEMODE NI!");
          break;
        case SHEARMODE:
          System.err.println("SHEARMODE NI!");
          break;
        case DRAWMODE:
          if (getDrawable() != null) {
            if (getDrawable().handleMouseDragged(grid.getClosestEvent(e))) {
              // Es sind gengend Informationen um das Objekt zu erzeugen.
              add(glasspane);
            }
          } else {
            System.err.println("UserDrawAction:\n\tgetMode() == DRAWMODE && getDrawable() == null");
          }
          break;
        default:
          System.err.println("UserDrawAction: \n\tNOT A DEFINED DRAWING MODE!!!");
      }
      glasspane.refresh();
      setPositionInfo(e);
    }

    public void mouseEntered(MouseEvent e) {
      GlassPane glasspane = null;
      if (e.getSource() instanceof GlassPane) glasspane = (GlassPane) e.getSource();

      // wenn nicht klar ist wohin gezeichnet werden kann, bzw worauf brechen wir ab.
      if (getNode() == null || glasspane == null) return;

      glasspane.setCursor(currentCursor);
    }

    public void mouseExited(MouseEvent e) {
    }

    public void mouseReleased(MouseEvent e) {
      GlassPane glasspane = null;
      if (e.getSource() instanceof GlassPane) glasspane = (GlassPane) e.getSource();
      // wenn nicht klar ist wohin gezeichnet werden kann, bzw worauf brechen wir ab.
      if (getNode() == null || glasspane == null) return;

      switch (getMode()) {
        case SELECTMODE:
          AbstractAccessPoint ap;
          Selectable selectable;
          ap = getCurrentAccessPoint();
          if (ap != null) {
            // Benutzer hat einen AccessPoint gedragged.

            Selectable sel = glasspane.getSelectable();
            if (sel instanceof Transformable) {
              // Eine Sicherheitsberprfung, da es eigentlich ein Transformable sein mu
              ((Transformable) sel).handleAccessPointReleased(e, ap);
            } else {
              System.err.println("UserDrawAction: \n\tEs waren AccessPoints vorhanden, obwohl die Auswahl nicht Transformable war!");
            }
          } else {
            if (remOnRelease != null) {
              glasspane.remSelection(remOnRelease);
            }
            if (clearAndAddOnRelease != null) {
              glasspane.clearSelection();
              glasspane.addSelection(Color.blue);
              glasspane.addSelection(clearAndAddOnRelease);
            }
            if (dragged && (selectable = glasspane.getSelectable()) != null) {
              if (selectable instanceof Transformable) {
                // Eine Sicherheitsberprfung, da es eigentlich ein Transformable sein mu
                ((Transformable) selectable).handleDrop(e, startPoint);
              }
            }
            clearAndAddOnRelease = null;
            remOnRelease = null;
            dragged = false;
          }
          break;
        case ROTATEMODE:
          System.err.println("ROTATEMODE NI!");
          break;
        case SHEARMODE:
          System.err.println("SHEARMODE NI!");
          break;
        case DRAWMODE:
          if (getDrawable() != null) {
            if (getDrawable().handleMouseReleased(grid.getClosestEvent(e))) {
              // Es sind gengend Informationen um das Objekt zu erzeugen.
              add(glasspane);
            }
          } else {
            System.err.println("UserDrawAction:\n\tgetMode() == DRAWMODE && getDrawable() == null");
          }
          break;
        default:
          System.err.println("UserDrawAction: \n\tNOT A DEFINED DRAWING MODE!!!");
      }

      // Da nun egal was losgelassen wurde, knnen wir den currentAccessPoint wieder null setzen
      setCurrentAccessPoint(null);
      canDrag = false;
      glasspane.refresh();
      tree.updateUI();
    }

    public void mouseClicked(MouseEvent e) {
      GlassPane glasspane = null;
      if (e.getSource() instanceof GlassPane) glasspane = (GlassPane) e.getSource();

      // wenn nicht klar ist wohin gezeichnet werden kann, bzw worauf brechen wir ab.
      if (getNode() == null || glasspane == null) return;

      // Solage nichts angeklickt wurde, kann man auch nichts ziehen.
      canDrag = false;

      switch (getMode()) {
        case SELECTMODE:
          AbstractAccessPoint ap;
          Selectable selectable;
          ap = hitsAccessPoint(e);
          if (ap != null) {
            // Benutzer hat einen AccessPoint angeklickt.

            Selectable sel = glasspane.getSelectable();
            if (sel instanceof Transformable) {
              // Eine Sicherheitsberprfung, da es eigentlich ein Transformable sein mu
            } else {
              System.err.println("UserDrawAction: \n\tEs waren AccessPoints vorhanden, obwohl die Auswahl nicht Transformable war!");
            }
          } else if ((selectable = hitsSelectable(e)) != null) {
            // Benutzer hat ein Selectable angeklickt.

          } else {
            // Benutzer hat nichts angeklickt.

          }

          break;
        case ROTATEMODE:
          System.err.println("ROTATEMODE NI!");
          break;
        case SHEARMODE:
          System.err.println("SHEARMODE NI!");
          break;
        case DRAWMODE:
          if (getDrawable() != null) {
            if (getDrawable().handleMouseClicked(grid.getClosestEvent(e))) {
              // Es sind gengend Informationen um das Objekt zu erzeugen.
              add(glasspane);
            }
          } else {
            System.err.println("UserDrawAction:\n\tgetMode() == DRAWMODE && getDrawable() == null");
          }
          break;
        default:
          System.err.println("UserDrawAction: \n\tNOT A DEFINED DRAWING MODE!!!");
      }
      glasspane.refresh();

    }


    public void mouseMoved(MouseEvent e) {

      GlassPane glasspane = null;
      if (e.getSource() instanceof GlassPane) glasspane = (GlassPane) e.getSource();

      // wenn nicht klar ist wohin gezeichnet werden kann, bzw worauf brechen wir ab.
      if (getNode() == null || glasspane == null) return;

      switch (getMode()) {
        case SELECTMODE:
          break;
        case ROTATEMODE:
          System.err.println("ROTATEMODE NI!");
          break;
        case SHEARMODE:
          System.err.println("SHEARMODE NI!");
          break;
        case DRAWMODE:
          if (getDrawable() != null) {
            if (getDrawable().handleMouseMoved(grid.getClosestEvent(e))) {
              // Es sind gengend Informationen um das Objekt zu erzeugen.
              add(glasspane);
            }
            glasspane.refresh();
          } else {
            System.err.println("UserDrawAction:\n\tgetMode() == DRAWMODE && getDrawable() == null");
          }
          break;
        default:
          System.err.println("UserDrawAction: \n\tNOT A DEFINED DRAWING MODE!!!");
      }
      setPositionInfo(e);
    }

    /** Liefert den aktuellen Modus zurck.
      * @return den aktuellen Modus.
      * @see SELECTMODE
      * @see DRAWMODE
      * @see ROTATEMODE
      * @see SHEARMODE
      */
    public int getMode() {
      return mode;
    }

    /** Setzt den aktuellen Modus.
      * @param mode der neue Modus.
      * @see SELECTMODE
      * @see DRAWMODE
      * @see ROTATEMODE
      * @see SHEARMODE
      */
    public void setMode(int mode) {
      if (this.mode == DRAWMODE && getDrawable() != null) {
        // Wir waren im Zeichenmodus. Dem vielleicht im Zeichnen befindlichen
        // Objekt die mglichkeit geben sich fertigzustellen.
        getDrawable().handleTermination();
        // add(glasspane);
      }
      this.mode = mode;
      currentCursor = Cursor.getDefaultCursor();
    }

    /** Liefert den aktuellen Knoten, an dem neue Objekte eingehngt werden.
      * @return den aktuellen Knoten.
      */
    public DefaultMutableTreeNode getNode() {
      return node;
    }

    /** Setzt den aktuellen Knoten, an dem neue Objekte eingefgt werden.
      * @param der neue Knoten.
      */
    public void setNode(DefaultMutableTreeNode node) {
      this.node = node;
    }

    /** Liefert das aktuelle Drawable, das benutzt wird um neue Objekte zu zeichnen.
      * @return Das aktuelle Drawable.
      */
    public Drawable getDrawable() {
      return drawable;
    }

    /** Setzt das aktuelle Drawable, das benutzt wird um neue Objekte zu zeichnen.
      * @param drawable Das neue Drawable.
      */
    public void setDrawable(Drawable drawable) {
      this.drawable = drawable;
      currentCursor = drawable.supportCursor();
    }

    /** Setzt den Modus auf DRAWMODE und das neue Drawable.
      * @param drawable Das neue Drawable.
      */
    public void setDrawMode(Drawable drawable) {
      setMode(DRAWMODE);
      setDrawable(drawable);
      System.err.println("Setting drawmode");
    }

    /** Fgt das AbstractGraphObject als neues Blatt an den Knoten node an.
      * @param o Das AbstractGraphObject, das hizugefgt werden soll.
      */
    private void add(AbstractGraphObject o) {
      // DefaultMutableTreeNode aNode = new DefaultMutableTreeNode(o);
      addObject(getNode(), o);
    }

    /** Versucht von dem aktuellen Drawable eine Instanz zu erhalten und fgt diese
      * dann im Baum ein.
      * @see add(AbstractGraphObject o)
      */
    private void add(GlassPane gp) {
      if (getDrawable() != null) {
        AbstractGraphObject obj = getDrawable().getInstance();
        if (obj != null) {
          add(obj);
          gp.clearSelection();
          gp.addSelection(Color.blue);
          gp.addSelection(obj);
        }
      }
    }

    /** Prft ob einer der AccessPoints der aktuellen Auswahl angeklickt wurde.
      * @param p Die Mouseposition, die berprft werden soll.
      * @return Den angeklickten AccessPoint oder <tt>null</tt>.
      */
    private AbstractAccessPoint hitsAccessPoint(MouseEvent e) {
      GlassPane glasspane = null;
      boolean intersects = false;

      if (e.getSource() instanceof GlassPane) glasspane = (GlassPane) e.getSource();
      // wenn nicht klar ist wohin gezeichnet werden kann, bzw worauf brechen wir ab.
      if (getNode() == null || glasspane == null) return null;

      adjustMouseRectangle(e);

      if (glasspane.getSelectable() instanceof Transformable) {
        AbstractAccessPoint[] ap = ((Transformable) glasspane.getSelectable()).getAccessPoints(getMode());
        if (ap != null) {
          for (int i=0; i<ap.length; i++) {
            if (ap[i].getAppearance().intersects(mouseRectangle)) return ap[i];
          }
        }
      }

      return null;
    }

    /** Prft ob ein Selectable angeklickt wurde. Der Scope dieser Funktion ist:
      * alle Selectables die Kinder von node sind.
      * @param p Die Mouseposition, die berprft werden soll.
      * @return Das angeklickte Selectable oder <tt>null</tt>.
      */
    private Selectable hitsSelectable(MouseEvent e) {
      GlassPane glasspane = null;
      boolean intersects = false;

      if (e.getSource() instanceof GlassPane) glasspane = (GlassPane) e.getSource();
      // wenn nicht klar ist wohin gezeichnet werden kann, bzw worauf brechen wir ab.
      if (getNode() == null || glasspane == null) return null;

      adjustMouseRectangle(e);

      for (Enumeration enum = getNode().breadthFirstEnumeration(); enum.hasMoreElements(); ) {

        Object nextnode = enum.nextElement();

        Object obj = ((DefaultMutableTreeNode) nextnode).getUserObject();

        if (obj instanceof AbstractGraphObject) {
          // ein GraphObject und alles wird gut...
          AbstractGraphObject grph = (AbstractGraphObject) obj;
          if (grph.isFilled()) {
            intersects = grph.intersects(mouseRectangle);
          } else {
            intersects = AbstractGraphObject.intersectsBoundary(grph, mouseRectangle);
          }
        } else if (obj instanceof Selectable) {
          // Wer macht denn so was?! aber na ja geht auch...
          intersects = ((Selectable) obj).intersects(mouseRectangle);
        }

        if (intersects) {
          return (Selectable) obj;
        }
      }

      return null;
    }

    private void adjustMouseRectangle(MouseEvent e) {
      mouseRectangle.setRect(e.getX() - (mouseRectangle.getWidth()/2),
          e.getY() - (mouseRectangle.getHeight()/2), mouseRectangle.getWidth(),
          mouseRectangle.getHeight());
    }


    /** Liefert den currentAccessPoint.
      * @return den currentAccessPoint.
      */
    private AbstractAccessPoint getCurrentAccessPoint() {
      return currentAccessPoint;
    }

    /** Setzt den currentAccessPoint.
      * @param ap der neue AccessPoint.
      */
    private void setCurrentAccessPoint(AbstractAccessPoint ap) {
      this.currentAccessPoint = ap;
    }


    public DefaultMutableTreeNode  addObject(DefaultMutableTreeNode parentNode, Object child) {
      DefaultMutableTreeNode childNode = new DefaultMutableTreeNode(child);
      childNode.setAllowsChildren(false);
      treeModel.insertNodeInto(childNode, parentNode, parentNode.getChildCount());
      // Make sure the user can see the lovely new node.
      tree.scrollPathToVisible(new TreePath(childNode.getPath()));
      return childNode;
    }

    public void setPositionLabel(JLabel l) {
      this.lblPosition = l;
    }

    private void setPositionInfo(MouseEvent e) {
      boolean metric = isMetric.isSelected();
      if (lblPosition != null) {
        // this.lblPosition.setText("(" + grd.posToUnit(e.getX(),metric) + "; " + Rule.posToUnit(e.getY(),metric) + ")");
      }
    }

  }

  void treeShapes_keyPressed(KeyEvent e) {
    switch (e.getKeyCode()){
      case KeyEvent.VK_DELETE :
        TreePath[] selection = treeShapes.getSelectionPaths();
        DefaultMutableTreeNode node;
        if (selection == null) break;
        for (int i=0; i< selection.length; i++) {
          // ((DefaultMutableTreeNode) selection[i].getLastPathComponent()).removeFromParent();
          node = (DefaultMutableTreeNode) selection[i].getLastPathComponent();
          if (node.getUserObject() instanceof AbstractGraphObject || node.getUserObject() instanceof Layer) {
            treeModel.removeNodeFromParent(node);
            glassPane.clearSelection();
            glassPane.refresh();
          }
        }
        // treeShapes.updateUI();
    }
  }


}



class MainFrame_menuFileExit_ActionAdapter implements ActionListener {
  MainFrame adaptee;

  MainFrame_menuFileExit_ActionAdapter(MainFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.fileExit_actionPerformed(e);
  }
}

class MainFrame_menuHelpAbout_ActionAdapter implements ActionListener {
  MainFrame adaptee;

  MainFrame_menuHelpAbout_ActionAdapter(MainFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.helpAbout_actionPerformed(e);
  }
}

class MainFrame_butSelect_actionAdapter implements java.awt.event.ActionListener {
  MainFrame adaptee;

  MainFrame_butSelect_actionAdapter(MainFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.butSelect_actionPerformed(e);
  }
}

class MainFrame_butLine_actionAdapter implements java.awt.event.ActionListener {
  MainFrame adaptee;

  MainFrame_butLine_actionAdapter(MainFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.butLine_actionPerformed(e);
  }
}

class MainFrame_butRectangle_actionAdapter implements java.awt.event.ActionListener {
  MainFrame adaptee;

  MainFrame_butRectangle_actionAdapter(MainFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.butRectangle_actionPerformed(e);
  }
}

class MainFrame_butEllipse_actionAdapter implements java.awt.event.ActionListener {
  MainFrame adaptee;

  MainFrame_butEllipse_actionAdapter(MainFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.butEllipse_actionPerformed(e);
  }
}

class MainFrame_butNewLayer_actionAdapter implements java.awt.event.ActionListener {
  MainFrame adaptee;

  MainFrame_butNewLayer_actionAdapter(MainFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.butNewLayer_actionPerformed(e);
  }
}

class MainFrame_butLayerVisible_actionAdapter implements java.awt.event.ActionListener {
  MainFrame adaptee;

  MainFrame_butLayerVisible_actionAdapter(MainFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.butLayerVisible_actionPerformed(e);
  }
}