/*******************************************************************************
  *
  *  program     : Rule.java
  *  author      : (modified tutorial example)
  *  version     : 2000-10-19(001)
  *  (c)         :
  *  email       : heljanic@agent.fho-emden.de
  *  description : some description here
  *
  ******************************************************************************
  * modifications:
  * date: ******* who: ****** description: *************************************
  * ----------------------------------------------------------------------------
  * 2000-10-19    heljanic    your description here
  * ----------------------------------------------------------------------------
  ******************************************************************************
  * comments:
  *
  ******************************************************************************
  * license:
  *
*******************************************************************************/
package jdraw;

import java.awt.*;
import javax.swing.*;
import java.text.*;

public class Rule extends JComponent {

    /** The simple Grid used to display the rulers. */
    SimpleGrid grd;

    public static DecimalFormat df = new DecimalFormat("####.##");
    public static final int INCH = Toolkit.getDefaultToolkit().
            getScreenResolution();
    public static final int HORIZONTAL = 0;
    public static final int VERTICAL = 1;
    public static final int SIZE = 25;

    public int orientation;
    private double increment;
    private double units;

    private int intervals = 1;

    public Rule(int o, SimpleGrid grd) {
        orientation = o;
        this.grd = grd;
        setIncrementAndUnits();
    }

    public void setIncrementAndUnits() {
        units =  grd.getUnit().getOneUnitInDot();
        increment = units / intervals;
    }

    public double getIncrement() {
        return increment;
    }

    public void setPreferredHeight(int ph) {
        setPreferredSize(new Dimension(SIZE, ph));
    }

    public void setPreferredWidth(int pw) {
        setPreferredSize(new Dimension(pw, SIZE));
    }

    public void paintComponent(Graphics g) {
        Rectangle drawHere = g.getClipBounds();

        // Fill clipping area with dirty brown/orange.
        g.setColor(new Color(230, 230, 230));
        g.fillRect(drawHere.x, drawHere.y, drawHere.width, drawHere.height);

        // Do the ruler labels in a small font that's black.
        g.setFont(new Font("SansSerif", Font.PLAIN, 10));
        g.setColor(Color.black);

        // Some vars we need.
        int end = 0;
        int start = 0;
        int tickLength = 0;
        String text = null;

        // Use clipping bounds to calculate first tick and last tick location.
        if (orientation == HORIZONTAL) {
            start = (int) ((drawHere.x / increment) * increment);
            end = (int) ((((double) (drawHere.x + drawHere.width )) / increment + 1.0) * increment);
        } else {
            start = (int) ((drawHere.y / increment) * increment);
            end = (int) ((((double) (drawHere.y + drawHere.height)) / increment + 1.0) * increment);
        }

        // Make a special case of 0 to display the number
        // within the rule and draw a units label.
        if (start == 0) {
            text = Integer.toString(0) + grd.getUnit().getName();
            tickLength = 10;
            if (orientation == HORIZONTAL) {
                g.drawLine(0, SIZE-1, 0, SIZE-tickLength-1);
                g.drawString(text, 2, 10);
            } else {
                g.drawLine(SIZE-1, 0, SIZE-tickLength-1, 0);
                g.drawString(text, 2, 10);
            }
            text = null;
            start = (int) increment;
        }

        // ticks and labels
        int lastTick = (int) (end / increment);
        int firstTick = (int) (start / increment);
        for (int i = firstTick; i < lastTick; i++) {
            int position = (int) (i * increment);
            if ((i % intervals ) == 0)  {
                tickLength = 10;
                text = Integer.toString(i);
            } else {
                tickLength = 7;
                text = null;
            }
            if (tickLength != 0) {
                if (orientation == HORIZONTAL) {
                    g.drawLine(position, SIZE-1, position, SIZE-tickLength-1);
                    if (text != null)
                        g.drawString(text, position-3, 10);
                } else {
                    g.drawLine(SIZE-1, position, SIZE-tickLength-1, position);
                    if (text != null)
                        g.drawString(text, 4, position+3);
                }
            }
        }
    }
}
