/*******************************************************************************
  *
  *  program     : Selectable.java
  *  author      : Helge Janicke
  *  version     : 2000-10-19(001)
  *  (c)         : Helge Janicke, Karsten Wolke, Niels-Peter de Witt
  *  email       : heljanic@agent.fho-emden.de
  *  description :
  ******************************************************************************
  * modifications:
  * date: ******* who: ****** description: *************************************
  * ----------------------------------------------------------------------------
  * 2000-10-19    heljanic
  * ----------------------------------------------------------------------------
  ******************************************************************************
  * comments:
  *
  ******************************************************************************
  * license:
  *
*******************************************************************************/
package jdraw;

import java.awt.geom.Rectangle2D;
import java.awt.geom.Point2D;
import java.awt.Rectangle;

/** Dieses Inteface definiert alle Methoden die implementiert werden mssen, damit ein Objekt
 * selektierbar ist. Diese Methoden werden auch vom Inteface java.awt.Shape definiert. Eine Klasse,
 * die Shape implementiert kann also ohne weitere nderungen auch Selectable implementieren.
 */
public interface Selectable {
  public Rectangle getBounds();
  public Rectangle2D getBounds2D();
  public boolean contains(double x, double y);
  public boolean contains(Point2D p);
  public boolean intersects(double x, double y, double w, double h);
  public boolean intersects(Rectangle2D r);
  public boolean contains(double x, double y, double w, double h);
  public boolean contains(Rectangle2D r);
}