/*******************************************************************************
  *
  *  program     : jdRectangleGenerator.java
  *  author      : Helge Janicke
  *  version     : 2000-10-19(001)
  *  (c)         : Helge Janicke, Karsten Wolke, Niels-Peter de Witt
  *  email       : heljanic@agent.fho-emden.de
  *  description : Generiert ein neues jdRectangle Objekt.
  *
  ******************************************************************************
  * modifications:
  * date: ******* who: ****** description: *************************************
  * ----------------------------------------------------------------------------
  * 2000-10-19    heljanic    your description here
  * ----------------------------------------------------------------------------
  ******************************************************************************
  * comments:
  *
  ******************************************************************************
  * license:
  *
*******************************************************************************/
package jdraw;

import java.awt.event.MouseEvent;
import java.awt.Cursor;
import java.net.URL;
import javax.swing.JEditorPane;

import java.awt.geom.*;

/** Diese Klasse generiert ein jdRectangle Objekt aus Mousevents.<br>
  * 1. Drcken der linken MouseTaste, Wahl eines Eckpunkts<br>
  * 2. Aufziehen bis in die gewnschte Gre<br>
  * 3. Loslassen der Mousetaste, Wahl des zweiten Eckpunktes.
  */
public class jdRectangleGenerator implements Drawable {
  GlassPane glasspane = null;
  Rectangle2D.Double r;
  Point2D p1, p2;
  private JEditorPane helpPane=null;

  /** Erzeugt einen neuen jdLineGenerator. */
  public jdRectangleGenerator() {
  }

  public boolean handleMousePressed(MouseEvent e) {
    r = new Rectangle2D.Double(0,0,0,0);
    p1 = e.getPoint();
    System.err.println("p1 = " + p1);
    System.err.println("r = " + r);
    r.setRect(p1.getX(), p1.getY(), 0, 0);
    glasspane.addShape(r);
    return false;
  }

  public boolean handleMouseDragged(MouseEvent e) {
    p2 = e.getPoint();
    Rectangle2D.Double rect = r;
    double rectx,recty;
    rectx = p1.getX();
    recty = p1.getY();

    if ((p1.getX()>p2.getX())&&(p1.getY()>p2.getY()))
      {  rect.x = e.getX();
         rect.y = e.getY();
         rect.width=rectx-e.getX();
         rect.height=recty-e.getY();
      }
      else if ((rectx>e.getX())&&(recty<e.getY()))
      {  rect.x=e.getX();
         rect.y=recty;
         rect.width=rectx-e.getX();
         rect.height=e.getY()-recty;
      }
      else if ((rectx<e.getX())&&(recty>e.getY()))
      {  rect.x=rectx;
         rect.y=e.getY();
         rect.width=e.getX()-rectx;
         rect.height=recty-e.getY();
      }
      else if ((rectx<e.getX())&&(recty<e.getY()))
      {  rect.x=rectx;
         rect.y=recty;
         rect.width=e.getX()-rectx;
         rect.height=e.getY()-recty;
      }

    return false;
  }

  public boolean handleMouseMoved(MouseEvent e) {
    return false;
  }

  public boolean handleMouseReleased(MouseEvent e) {
    glasspane.remShape(r);
    return true;
  }

  public boolean handleMouseClicked(MouseEvent e) {
    return false;
  }

  public void handleTermination() {
    r = null;
  }

  public AbstractGraphObject getInstance() {
    if (r != null) return new jdRectangle((Rectangle2D) r.clone());
    return null;
  }

  public void setGlassPane(GlassPane glasspane) {
    this.glasspane = glasspane;
  }

  public Cursor supportCursor() {
    return Cursor.getPredefinedCursor(Cursor.CROSSHAIR_CURSOR);
  }

  public URL getHTMLHelp() {
    return null;
  }

  public void setHTMLHelpPane( JEditorPane e ) {
    this.helpPane = e;
  }

  private void setHelp(String s) {
    if (helpPane==null) return;
    helpPane.setText("<html>THIS is a test</HTML");
  }


}